<%@ Page Language="C#" AutoEventWireup="true" Inherits="System.Web.UI.Page" %>
<%@ Import Namespace="System.Net.Mail" %>
<%@ Import Namespace="System.Net" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
    <title>Mail Test 1.0</title>
    
    <script runat="server" type="text/C#">

	protected void btnSend_Click(object sender, EventArgs e)
	{
		// reset the message label
		this.lblMessage.Text = String.Empty;

		//create the mail message
		MailMessage mail = new MailMessage();

		//set the addresses
        try
        {
            mail.From = new MailAddress(this.txtFrom.Text);
            mail.To.Add(this.txtTo.Text);
        }
        catch (Exception ex)
        {
            this.lblMessage.Style["color"] = "red";
            this.lblMessage.Text = ex.Message;
            return;
        }

		//set the content
		mail.Subject = this.txtSubject.Text;
		mail.Body = this.txtMessage.Text;

		mail.Body += string.Format("\n\n\n--[ Options used ]------------------------\n");
		mail.Body += string.Format("Sent: {0}\n", DateTime.Now);
		mail.Body += string.Format("Server: {0}\n", txtIp.Text);
		mail.Body += string.Format("Server port: {0}\n", txtSmtpPort.Text); 
		mail.Body += string.Format("Use SSL: {0}\n", cbEnableSsl.Checked);
		mail.Body += string.Format("Authenticate: {0}\n", cbAuthenticate.Checked);
		mail.Body += string.Format("Username: {0}\n", txtUserName.Text);
        mail.Body += string.Format("Client IP: {0}\n", Request.ServerVariables["REMOTE_ADDR"]);
        mail.Body += string.Format("Web server: {0}\n", Request.ServerVariables["SERVER_NAME"]);
        mail.Body += string.Format("Server address: {0}\n", Request.ServerVariables["LOCAL_ADDR"]);
        

		SmtpClient smtp;
		if (this.txtIp.Text == String.Empty)
		{
			smtp = new SmtpClient();
		}
		else
		{
			smtp = new SmtpClient(this.txtIp.Text);
		}

		if (cbEnableSsl.Checked == true)
		{
			smtp.EnableSsl = true;
		}

		if (this.cbAuthenticate.Checked == true)
		{
			//to authenticate we set the username and password properites on the SmtpClient
			smtp.Credentials = new NetworkCredential(this.txtUserName.Text, this.txtPassword.Text);
		}

		//send the message
		this.lblMessage.Style["color"] = "red";
		try
		{
			smtp.Send(mail);

			this.lblMessage.Style["color"] = "black";

			this.lblMessage.Text = "<p style=\"color: darkgreen; font-weight: bold;\">Message is sent!</p>";

			this.lblMessage.Text += "<p><i>Copy of mail message sent:</i><br><pre style=\"background-color: #efefef;\">" + mail.Body + "</pre></p>";

		}
		catch (System.Net.Mail.SmtpFailedRecipientsException smtpFaildRecsEx)
		{
			this.lblMessage.Text = smtpFaildRecsEx.Message + "<br/><br/>" + smtpFaildRecsEx.GetBaseException().Message + "";
		}
		catch (System.Net.Mail.SmtpFailedRecipientException smtpFaildRecEx)
		{
			this.lblMessage.Text = smtpFaildRecEx.Message + "<br/><br/>" + smtpFaildRecEx.GetBaseException().Message + "";
		}
		catch (System.Net.Mail.SmtpException smtpEx)
		{
			this.lblMessage.Text = smtpEx.Message + "<br/><br/>" + smtpEx.GetBaseException().Message + "";
		}
		catch (System.Exception ex)
		{
			this.lblMessage.Text = ex.Message + "<br/><br/>" + ex.GetBaseException().Message + "";
		}

		
	}    
    </script>
</head>
<body>
    <form id="form1" runat="server">
    <div>
        <h1>Mail Test 1.0 - Levn Labs</h1>
        <p style="color: darkred;"><strong>Please note!</strong><br />It is <u>not</u> recommended to let this script be available on a public website due to the high risk of being abused.</p>
        <p>
            <asp:ValidationSummary ID="ValidationSummary1" EnableClientScript="true" ShowSummary="true" DisplayMode="list" runat="server" />
            <asp:Label ID="lblMessage" runat="server"></asp:Label>
            <br />
        </p>
        
        <asp:Label ID="Label1" runat="server" Text="From:"></asp:Label>
        <br />
        <asp:TextBox ID="txtFrom" runat="server" Width="350px">
        </asp:TextBox><asp:RequiredFieldValidator ID="RequiredFieldValidator1" ControlToValidate="txtFrom" runat="server" ErrorMessage="From address is required"> *</asp:RequiredFieldValidator>
        <br />
        <br />
        <asp:Label ID="Label2" runat="server" Text="To:"></asp:Label>
        <br />
        <asp:TextBox ID="txtTo" runat="server" Width="350px"></asp:TextBox>
        </asp:TextBox><asp:RequiredFieldValidator ID="RequiredFieldValidator2" ControlToValidate="txtTo" runat="server" ErrorMessage="To address is required"> *</asp:RequiredFieldValidator>
        <br />
        <br />
        <asp:Label ID="Label3" runat="server" Text="Subject:"></asp:Label>
        <br />
        <asp:TextBox ID="txtSubject" runat="server" Width="350px" Text="This is an test email"></asp:TextBox>
        <br />
        <br />
        <asp:Label ID="Label4" runat="server" Text="Message:"></asp:Label>
        <br />
        <asp:TextBox ID="txtMessage" runat="server" TextMode="MultiLine" Rows="5" 
            Text="This is the message" Width="350px">This is the test mail message</asp:TextBox>
        <br />
        <br />
        <asp:Label ID="Label5" runat="server" Text="Name/IP of the host computer used for SMTP transactions"></asp:Label>
        <br />
        <asp:TextBox ID="txtIp" runat="server" Width="350px"></asp:TextBox>
        <br />
        <br />
        <asp:Label ID="Label6" runat="server" Text="SMTP Port:"></asp:Label>
        <br />
        <asp:TextBox ID="txtSmtpPort" runat="server" Width="350px"></asp:TextBox>
        <br />
        <br />
        <asp:CheckBox ID="cbEnableSsl" runat="server" Text="Enable SSL" />
        <br />
        <br />
        <asp:CheckBox ID="cbAuthenticate" runat="server" Text="Authenticate to send an e-mail" />
        <br />
        <br />
        <asp:Label ID="Label7" runat="server" Text="User Name:"></asp:Label>
        <br />
        <asp:TextBox ID="txtUserName" runat="server" Width="350px"></asp:TextBox>
        <br />
        <br />
        <asp:Label ID="Label8" runat="server" Text="Password:"></asp:Label>
        <br />
        <asp:TextBox ID="txtPassword" runat="server" TextMode="Password" Width="350px"></asp:TextBox>
        <br />
        <br />
        <asp:Button ID="btnSend" runat="server" Text="Send" onclick="btnSend_Click" />
    </div>
    <br />
    <hr />
    <p>Script retained from <a href="http://labs.leven.se" target="_blank">Levn Labs</a>: <a href="http://labs.leven.se/Snippets/MailTest.htm" target="_blank">http://labs.leven.se/Snippets/MailTest.htm</a></p>
    <p style="font-style: italic;">Thanks to Bengt Hasselgren for making the foundation of this script!</p>
    </form>
</body>
</html>
